<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="pl">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=11"/>
<meta name="generator" content="Doxygen 1.9.7"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Robomap: Plik źródłowy SerialPort.cpp</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr id="projectrow">
  <td id="projectalign">
   <div id="projectname">Robomap<span id="projectnumber">&#160;0.1</span>
   </div>
   <div id="projectbrief">RM</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Wygenerowano przez Doxygen 1.9.7 -->
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function() {
  initMenu('',false,false,'search.php','Szukaj');
});
/* @license-end */
</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(document).ready(function(){initNavTree('_serial_port_8cpp_source.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<div class="header">
  <div class="headertitle"><div class="title">SerialPort.cpp</div></div>
</div><!--header-->
<div class="contents">
<a href="_serial_port_8cpp.html">Idź do dokumentacji tego pliku.</a><div class="fragment"><div class="line"><a id="l00001" name="l00001"></a><span class="lineno">    1</span><span class="preprocessor">#include &quot;<a class="code" href="_serial_port_8hpp.html">SerialPort.hpp</a>&quot;</span></div>
<div class="line"><a id="l00002" name="l00002"></a><span class="lineno">    2</span> </div>
<div class="line"><a id="l00013" name="l00013"></a><span class="lineno"><a class="line" href="class_serial_port.html#aca7d6ec84770df9715926afd3226454b">   13</a></span><a class="code hl_function" href="class_serial_port.html#aca7d6ec84770df9715926afd3226454b">SerialPort::SerialPort</a>() { }</div>
<div class="line"><a id="l00028" name="l00028"></a><span class="lineno"><a class="line" href="class_serial_port.html#ab8617347c0bd495e80d39e563ec8e750">   28</a></span><span class="keywordtype">bool</span> <a class="code hl_function" href="class_serial_port.html#ab8617347c0bd495e80d39e563ec8e750">SerialPort::startConnection</a>()</div>
<div class="line"><a id="l00029" name="l00029"></a><span class="lineno">   29</span>{</div>
<div class="line"><a id="l00030" name="l00030"></a><span class="lineno">   30</span>    <span class="keywordtype">bool</span> serial_opened = <span class="keyword">false</span>;</div>
<div class="line"><a id="l00031" name="l00031"></a><span class="lineno">   31</span> </div>
<div class="line"><a id="l00032" name="l00032"></a><span class="lineno">   32</span>    <a class="code hl_variable" href="class_serial_port.html#a222bb0e736430908b2145a1e24459d67">port_desc</a> = open(<span class="stringliteral">&quot;/dev/rfcomm0&quot;</span>, O_RDWR | O_NONBLOCK);</div>
<div class="line"><a id="l00033" name="l00033"></a><span class="lineno">   33</span> </div>
<div class="line"><a id="l00034" name="l00034"></a><span class="lineno">   34</span>    <span class="keywordflow">if</span>(<a class="code hl_variable" href="class_serial_port.html#a222bb0e736430908b2145a1e24459d67">port_desc</a> &gt; 0)</div>
<div class="line"><a id="l00035" name="l00035"></a><span class="lineno">   35</span>    {</div>
<div class="line"><a id="l00036" name="l00036"></a><span class="lineno">   36</span>        <a class="code hl_function" href="transparam_8hh.html#adae5ef433c18e71af7b1a18cd4c107e6">SetTransParam</a>(<a class="code hl_variable" href="class_serial_port.html#a222bb0e736430908b2145a1e24459d67">port_desc</a>);</div>
<div class="line"><a id="l00037" name="l00037"></a><span class="lineno">   37</span> </div>
<div class="line"><a id="l00038" name="l00038"></a><span class="lineno">   38</span>        <a class="code hl_variable" href="class_serial_port.html#a97cc08ccce84780fd625ea8ae4dcc917">keep_reading</a> = <span class="keyword">true</span>;</div>
<div class="line"><a id="l00039" name="l00039"></a><span class="lineno">   39</span>        serial_opened = <span class="keyword">true</span>;</div>
<div class="line"><a id="l00040" name="l00040"></a><span class="lineno">   40</span>    }</div>
<div class="line"><a id="l00041" name="l00041"></a><span class="lineno">   41</span> </div>
<div class="line"><a id="l00042" name="l00042"></a><span class="lineno">   42</span>    <span class="keywordflow">return</span> serial_opened;</div>
<div class="line"><a id="l00043" name="l00043"></a><span class="lineno">   43</span>}</div>
<div class="line"><a id="l00050" name="l00050"></a><span class="lineno"><a class="line" href="class_serial_port.html#a58d7a924c500dbbd169ab7ed0f60afef">   50</a></span><span class="keywordtype">bool</span> <a class="code hl_function" href="class_serial_port.html#a58d7a924c500dbbd169ab7ed0f60afef">SerialPort::endConnection</a>()</div>
<div class="line"><a id="l00051" name="l00051"></a><span class="lineno">   51</span>{</div>
<div class="line"><a id="l00052" name="l00052"></a><span class="lineno">   52</span>    close(<a class="code hl_variable" href="class_serial_port.html#a222bb0e736430908b2145a1e24459d67">port_desc</a>);</div>
<div class="line"><a id="l00053" name="l00053"></a><span class="lineno">   53</span>    <a class="code hl_variable" href="class_serial_port.html#a97cc08ccce84780fd625ea8ae4dcc917">keep_reading</a> = <span class="keyword">false</span>;</div>
<div class="line"><a id="l00054" name="l00054"></a><span class="lineno">   54</span>    <span class="keywordflow">return</span> <span class="keyword">true</span>;</div>
<div class="line"><a id="l00055" name="l00055"></a><span class="lineno">   55</span>}</div>
<div class="line"><a id="l00069" name="l00069"></a><span class="lineno"><a class="line" href="class_serial_port.html#af29d6aadc436a6440cfa66fbf8c403ad">   69</a></span><span class="keywordtype">bool</span> <a class="code hl_function" href="class_serial_port.html#af29d6aadc436a6440cfa66fbf8c403ad">SerialPort::receiveData</a>()</div>
<div class="line"><a id="l00070" name="l00070"></a><span class="lineno">   70</span>{</div>
<div class="line"><a id="l00071" name="l00071"></a><span class="lineno">   71</span>    <span class="keywordflow">if</span>(<a class="code hl_variable" href="class_serial_port.html#a222bb0e736430908b2145a1e24459d67">port_desc</a> &lt; 0)</div>
<div class="line"><a id="l00072" name="l00072"></a><span class="lineno">   72</span>        <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a id="l00073" name="l00073"></a><span class="lineno">   73</span> </div>
<div class="line"><a id="l00074" name="l00074"></a><span class="lineno">   74</span>    std::string data_frame;</div>
<div class="line"><a id="l00075" name="l00075"></a><span class="lineno">   75</span>    <span class="keywordtype">bool</span> read_status = <span class="keyword">false</span>;</div>
<div class="line"><a id="l00076" name="l00076"></a><span class="lineno">   76</span> </div>
<div class="line"><a id="l00077" name="l00077"></a><span class="lineno">   77</span>    <span class="keywordflow">if</span>(<a class="code hl_function" href="odbieranie_8hh.html#aac03f023f654bbad587c2f5c0894e0bf">RS232_Odbierz</a>(<a class="code hl_function" href="class_serial_port.html#a19e9af50f81a100e0e9bbaa5e2027b3d">returnDecriptor</a>(), data_frame, <a class="code hl_define" href="_serial_port_8hpp.html#acdd0eacf8c0ad94beabef95f32d78009">FRAME_LIMIT</a>, 100))</div>
<div class="line"><a id="l00078" name="l00078"></a><span class="lineno">   78</span>    {</div>
<div class="line"><a id="l00079" name="l00079"></a><span class="lineno">   79</span>        data_frame[data_frame.length()] = <span class="charliteral">&#39;\0&#39;</span>;</div>
<div class="line"><a id="l00080" name="l00080"></a><span class="lineno">   80</span>        <span class="keywordtype">char</span> *new_frame = <span class="keyword">new</span> <span class="keywordtype">char</span>[data_frame.length() + 1];</div>
<div class="line"><a id="l00081" name="l00081"></a><span class="lineno">   81</span>        std::copy(data_frame.begin(), data_frame.end(), new_frame);</div>
<div class="line"><a id="l00082" name="l00082"></a><span class="lineno">   82</span>        read_status = <a class="code hl_function" href="_serial_port_8hpp.html#a21626d35c8ce984e1085d6224f0ba720">parseDataFrame</a>(new_frame, &amp;<a class="code hl_variable" href="class_serial_port.html#a343697523d58e3812ba0999cfa122f2d">data</a>, data_frame.length());</div>
<div class="line"><a id="l00083" name="l00083"></a><span class="lineno">   83</span>    }</div>
<div class="line"><a id="l00084" name="l00084"></a><span class="lineno">   84</span> </div>
<div class="line"><a id="l00085" name="l00085"></a><span class="lineno">   85</span>    <span class="keywordflow">return</span> read_status;</div>
<div class="line"><a id="l00086" name="l00086"></a><span class="lineno">   86</span>}</div>
<div class="line"><a id="l00102" name="l00102"></a><span class="lineno"><a class="line" href="_serial_port_8hpp.html#a21626d35c8ce984e1085d6224f0ba720">  102</a></span><span class="keywordtype">bool</span> <a class="code hl_function" href="_serial_port_8cpp.html#a21626d35c8ce984e1085d6224f0ba720">parseDataFrame</a>(<span class="keyword">const</span> <span class="keywordtype">char</span> *data_frame, <a class="code hl_class" href="class_robot_data.html">RobotData</a> *data, <span class="keywordtype">int</span> data_length)</div>
<div class="line"><a id="l00103" name="l00103"></a><span class="lineno">  103</span>{</div>
<div class="line"><a id="l00104" name="l00104"></a><span class="lineno">  104</span>    <span class="comment">// Rzutowanie na strumień wejściowy</span></div>
<div class="line"><a id="l00105" name="l00105"></a><span class="lineno">  105</span>    std::istringstream readed_line(data_frame);</div>
<div class="line"><a id="l00106" name="l00106"></a><span class="lineno">  106</span>    <span class="keywordtype">char</span> header;</div>
<div class="line"><a id="l00107" name="l00107"></a><span class="lineno">  107</span>    <span class="comment">// Wczytanie znaku startu</span></div>
<div class="line"><a id="l00108" name="l00108"></a><span class="lineno">  108</span>    readed_line &gt;&gt; header;</div>
<div class="line"><a id="l00109" name="l00109"></a><span class="lineno">  109</span> </div>
<div class="line"><a id="l00110" name="l00110"></a><span class="lineno">  110</span>    <span class="comment">// Sprawdzenie czy początek linii się zgadza</span></div>
<div class="line"><a id="l00111" name="l00111"></a><span class="lineno">  111</span>    <span class="keywordflow">if</span>(header != <span class="charliteral">&#39;X&#39;</span> || readed_line.fail() || data_length &lt;= 1)</div>
<div class="line"><a id="l00112" name="l00112"></a><span class="lineno">  112</span>        <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a id="l00113" name="l00113"></a><span class="lineno">  113</span> </div>
<div class="line"><a id="l00114" name="l00114"></a><span class="lineno">  114</span>    <span class="keywordtype">int</span> current_data = 0;</div>
<div class="line"><a id="l00115" name="l00115"></a><span class="lineno">  115</span>    <span class="comment">// Zczytanie danych z czujników odległości</span></div>
<div class="line"><a id="l00116" name="l00116"></a><span class="lineno">  116</span>    <span class="keywordflow">for</span>(<span class="keywordtype">int</span> i = 0; i &lt; 4; ++i)</div>
<div class="line"><a id="l00117" name="l00117"></a><span class="lineno">  117</span>    {</div>
<div class="line"><a id="l00118" name="l00118"></a><span class="lineno">  118</span>        readed_line &gt;&gt; current_data;</div>
<div class="line"><a id="l00119" name="l00119"></a><span class="lineno">  119</span>        data-&gt;<a class="code hl_function" href="class_robot_data.html#aee64ded96944fd7d61557f566a5c804f">getDistance</a>(current_data, i);</div>
<div class="line"><a id="l00120" name="l00120"></a><span class="lineno">  120</span>    }</div>
<div class="line"><a id="l00121" name="l00121"></a><span class="lineno">  121</span>    <span class="comment">// Zczytanie danych z transoptorów</span></div>
<div class="line"><a id="l00122" name="l00122"></a><span class="lineno">  122</span>    <span class="keywordflow">for</span>(<span class="keywordtype">int</span> i = 0; i &lt; 2; ++i)</div>
<div class="line"><a id="l00123" name="l00123"></a><span class="lineno">  123</span>    {</div>
<div class="line"><a id="l00124" name="l00124"></a><span class="lineno">  124</span>        readed_line &gt;&gt; current_data;</div>
<div class="line"><a id="l00125" name="l00125"></a><span class="lineno">  125</span>        data-&gt;<a class="code hl_function" href="class_robot_data.html#affa0add6183e662083841442a9976cb3">getCounter</a>(current_data, i);</div>
<div class="line"><a id="l00126" name="l00126"></a><span class="lineno">  126</span>    }</div>
<div class="line"><a id="l00127" name="l00127"></a><span class="lineno">  127</span>    <span class="comment">// Zczytanie prędkości kół</span></div>
<div class="line"><a id="l00128" name="l00128"></a><span class="lineno">  128</span>    <span class="keywordflow">for</span>(<span class="keywordtype">int</span> i = 0; i &lt; 2; ++i)</div>
<div class="line"><a id="l00129" name="l00129"></a><span class="lineno">  129</span>    {</div>
<div class="line"><a id="l00130" name="l00130"></a><span class="lineno">  130</span>        readed_line &gt;&gt; current_data;</div>
<div class="line"><a id="l00131" name="l00131"></a><span class="lineno">  131</span>        data-&gt;<a class="code hl_function" href="class_robot_data.html#adc9b093e38bfe8ae8eaf3f70e5cacefa">getVelocity</a>(current_data, i);</div>
<div class="line"><a id="l00132" name="l00132"></a><span class="lineno">  132</span>    }</div>
<div class="line"><a id="l00133" name="l00133"></a><span class="lineno">  133</span>    <span class="comment">// Sprawdzenie CRC</span></div>
<div class="line"><a id="l00134" name="l00134"></a><span class="lineno">  134</span>    <span class="keywordtype">char</span> crc;</div>
<div class="line"><a id="l00135" name="l00135"></a><span class="lineno">  135</span>    readed_line &gt;&gt; std::hex &gt;&gt; crc;</div>
<div class="line"><a id="l00136" name="l00136"></a><span class="lineno">  136</span> </div>
<div class="line"><a id="l00137" name="l00137"></a><span class="lineno">  137</span>    <span class="comment">// Ponowne sprawdzenie poprawności wczytania</span></div>
<div class="line"><a id="l00138" name="l00138"></a><span class="lineno">  138</span>    <span class="keywordflow">if</span>(readed_line.fail() || !<a class="code hl_function" href="_serial_port_8cpp.html#a0466d31f193efdfcc7b4d13472a27254">checkCRC</a>(<span class="keyword">const_cast&lt;</span><span class="keywordtype">char</span>*<span class="keyword">&gt;</span>(data_frame), data_length, crc))</div>
<div class="line"><a id="l00139" name="l00139"></a><span class="lineno">  139</span>        <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a id="l00140" name="l00140"></a><span class="lineno">  140</span> </div>
<div class="line"><a id="l00141" name="l00141"></a><span class="lineno">  141</span>    <span class="keywordflow">return</span> <span class="keyword">true</span>;</div>
<div class="line"><a id="l00142" name="l00142"></a><span class="lineno">  142</span>}</div>
<div class="line"><a id="l00150" name="l00150"></a><span class="lineno"><a class="line" href="_serial_port_8hpp.html#a0466d31f193efdfcc7b4d13472a27254">  150</a></span><span class="keywordtype">bool</span> <a class="code hl_function" href="_serial_port_8cpp.html#a0466d31f193efdfcc7b4d13472a27254">checkCRC</a>(<span class="keywordtype">char</span> *data_frame, <span class="keywordtype">int</span> data_length, <span class="keywordtype">char</span> crc)</div>
<div class="line"><a id="l00151" name="l00151"></a><span class="lineno">  151</span>{</div>
<div class="line"><a id="l00152" name="l00152"></a><span class="lineno">  152</span>    <span class="keywordtype">char</span> clear_data[data_length - 5];</div>
<div class="line"><a id="l00153" name="l00153"></a><span class="lineno">  153</span>    std::copy(&amp;data_frame[2], &amp;data_frame[data_length - 3], clear_data);</div>
<div class="line"><a id="l00154" name="l00154"></a><span class="lineno">  154</span>    clear_data[data_length - 3] = <span class="charliteral">&#39;\0&#39;</span>;</div>
<div class="line"><a id="l00155" name="l00155"></a><span class="lineno">  155</span>    <span class="comment">// Tablica clear_data teraz zawiera wszystkie użyteczne dane ze znakiem terminatora</span></div>
<div class="line"><a id="l00156" name="l00156"></a><span class="lineno">  156</span>    <span class="keywordtype">char</span> new_crc = <a class="code hl_function" href="_serial_port_8cpp.html#a750bdeca814dbfc7b7010d4b30c56023">crc8</a>(clear_data, std::strlen(clear_data) - 1);</div>
<div class="line"><a id="l00157" name="l00157"></a><span class="lineno">  157</span> </div>
<div class="line"><a id="l00158" name="l00158"></a><span class="lineno">  158</span>    <span class="keywordflow">if</span>(new_crc != crc)</div>
<div class="line"><a id="l00159" name="l00159"></a><span class="lineno">  159</span>        <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a id="l00160" name="l00160"></a><span class="lineno">  160</span> </div>
<div class="line"><a id="l00161" name="l00161"></a><span class="lineno">  161</span>    <span class="keywordflow">return</span> <span class="keyword">true</span>;</div>
<div class="line"><a id="l00162" name="l00162"></a><span class="lineno">  162</span>}</div>
<div class="line"><a id="l00166" name="l00166"></a><span class="lineno"><a class="line" href="_serial_port_8hpp.html#a750bdeca814dbfc7b7010d4b30c56023">  166</a></span><span class="keywordtype">char</span> <a class="code hl_function" href="_serial_port_8cpp.html#a750bdeca814dbfc7b7010d4b30c56023">crc8</a>(<span class="keywordtype">char</span> *data_frame, <span class="keywordtype">int</span> data_length)</div>
<div class="line"><a id="l00167" name="l00167"></a><span class="lineno">  167</span>{</div>
<div class="line"><a id="l00168" name="l00168"></a><span class="lineno">  168</span>  <span class="keywordtype">char</span> *data = data_frame;</div>
<div class="line"><a id="l00169" name="l00169"></a><span class="lineno">  169</span>  <span class="keywordtype">char</span> crc = 0x00;</div>
<div class="line"><a id="l00170" name="l00170"></a><span class="lineno">  170</span>  <span class="keywordtype">char</span> extract;</div>
<div class="line"><a id="l00171" name="l00171"></a><span class="lineno">  171</span>  <span class="keywordtype">char</span> sum;</div>
<div class="line"><a id="l00172" name="l00172"></a><span class="lineno">  172</span>  <span class="keywordflow">for</span>(<span class="keywordtype">int</span> i = 0; i &lt;= data_length; ++i)</div>
<div class="line"><a id="l00173" name="l00173"></a><span class="lineno">  173</span>  {</div>
<div class="line"><a id="l00174" name="l00174"></a><span class="lineno">  174</span>    extract = *data;</div>
<div class="line"><a id="l00175" name="l00175"></a><span class="lineno">  175</span>    <span class="keywordflow">for</span> (<span class="keywordtype">char</span> tempI = 8; tempI; tempI--)</div>
<div class="line"><a id="l00176" name="l00176"></a><span class="lineno">  176</span>    {</div>
<div class="line"><a id="l00177" name="l00177"></a><span class="lineno">  177</span>      sum = (crc ^ extract) &amp; 0x01;</div>
<div class="line"><a id="l00178" name="l00178"></a><span class="lineno">  178</span>      crc &gt;&gt;= 1;</div>
<div class="line"><a id="l00179" name="l00179"></a><span class="lineno">  179</span>      <span class="keywordflow">if</span>(sum)</div>
<div class="line"><a id="l00180" name="l00180"></a><span class="lineno">  180</span>      crc ^= 0x8C;</div>
<div class="line"><a id="l00181" name="l00181"></a><span class="lineno">  181</span>      extract &gt;&gt;= 1;</div>
<div class="line"><a id="l00182" name="l00182"></a><span class="lineno">  182</span>    }</div>
<div class="line"><a id="l00183" name="l00183"></a><span class="lineno">  183</span>    data++;</div>
<div class="line"><a id="l00184" name="l00184"></a><span class="lineno">  184</span>  }</div>
<div class="line"><a id="l00185" name="l00185"></a><span class="lineno">  185</span>  <span class="keywordflow">return</span> crc;</div>
<div class="line"><a id="l00186" name="l00186"></a><span class="lineno">  186</span>}</div>
<div class="line"><a id="l00194" name="l00194"></a><span class="lineno"><a class="line" href="_serial_port_8hpp.html#a6362cdaadde6e3f843a85a3713bb1e0c">  194</a></span><span class="keywordtype">void</span> <a class="code hl_function" href="_serial_port_8cpp.html#a6362cdaadde6e3f843a85a3713bb1e0c">process</a>(<a class="code hl_class" href="class_serial_port.html">SerialPort</a> *serial)</div>
<div class="line"><a id="l00195" name="l00195"></a><span class="lineno">  195</span>{</div>
<div class="line"><a id="l00196" name="l00196"></a><span class="lineno">  196</span>    std::unique_lock&lt;std::mutex&gt; lock(<a class="code hl_variable" href="_main_window_8hpp.html#a1b56d40ec3cfbf9e16772d3c02374e9f">cm</a>);</div>
<div class="line"><a id="l00197" name="l00197"></a><span class="lineno">  197</span>    <span class="comment">// Wątek czeka na sygnał od zmiennej kondycyjnej</span></div>
<div class="line"><a id="l00198" name="l00198"></a><span class="lineno">  198</span>    <a class="code hl_variable" href="_main_window_8hpp.html#aad7bbf4191e375baee5f99ed26694706">start</a>.wait(lock);</div>
<div class="line"><a id="l00199" name="l00199"></a><span class="lineno">  199</span> </div>
<div class="line"><a id="l00200" name="l00200"></a><span class="lineno">  200</span>    <span class="keywordflow">while</span>(serial-&gt;<a class="code hl_function" href="class_serial_port.html#a04a364848114cc5e6d9fb618b6b0a66d">keepReading</a>())</div>
<div class="line"><a id="l00201" name="l00201"></a><span class="lineno">  201</span>        serial-&gt;<a class="code hl_function" href="class_serial_port.html#af29d6aadc436a6440cfa66fbf8c403ad">receiveData</a>();</div>
<div class="line"><a id="l00202" name="l00202"></a><span class="lineno">  202</span>}</div>
<div class="line"><a id="l00203" name="l00203"></a><span class="lineno">  203</span> </div>
<div class="line"><a id="l00204" name="l00204"></a><span class="lineno">  204</span> </div>
<div class="line"><a id="l00205" name="l00205"></a><span class="lineno">  205</span> </div>
<div class="line"><a id="l00206" name="l00206"></a><span class="lineno">  206</span> </div>
<div class="line"><a id="l00207" name="l00207"></a><span class="lineno">  207</span> </div>
<div class="line"><a id="l00208" name="l00208"></a><span class="lineno">  208</span> </div>
<div class="ttc" id="a_main_window_8hpp_html_a1b56d40ec3cfbf9e16772d3c02374e9f"><div class="ttname"><a href="_main_window_8hpp.html#a1b56d40ec3cfbf9e16772d3c02374e9f">cm</a></div><div class="ttdeci">std::mutex cm</div><div class="ttdef"><b>Definition</b> <a href="main_8cpp_source.html#l00008">main.cpp:8</a></div></div>
<div class="ttc" id="a_main_window_8hpp_html_aad7bbf4191e375baee5f99ed26694706"><div class="ttname"><a href="_main_window_8hpp.html#aad7bbf4191e375baee5f99ed26694706">start</a></div><div class="ttdeci">std::condition_variable start</div><div class="ttdef"><b>Definition</b> <a href="main_8cpp_source.html#l00007">main.cpp:7</a></div></div>
<div class="ttc" id="a_serial_port_8cpp_html_a0466d31f193efdfcc7b4d13472a27254"><div class="ttname"><a href="_serial_port_8cpp.html#a0466d31f193efdfcc7b4d13472a27254">checkCRC</a></div><div class="ttdeci">bool checkCRC(char *data_frame, int data_length, char crc)</div><div class="ttdoc">Sprawdza zgodność sumy kontrolnej CRC.</div><div class="ttdef"><b>Definition</b> <a href="_serial_port_8cpp_source.html#l00150">SerialPort.cpp:150</a></div></div>
<div class="ttc" id="a_serial_port_8cpp_html_a21626d35c8ce984e1085d6224f0ba720"><div class="ttname"><a href="_serial_port_8cpp.html#a21626d35c8ce984e1085d6224f0ba720">parseDataFrame</a></div><div class="ttdeci">bool parseDataFrame(const char *data_frame, RobotData *data, int data_length)</div><div class="ttdoc">Analizuje otrzymaną ramkę danych.</div><div class="ttdef"><b>Definition</b> <a href="_serial_port_8cpp_source.html#l00102">SerialPort.cpp:102</a></div></div>
<div class="ttc" id="a_serial_port_8cpp_html_a6362cdaadde6e3f843a85a3713bb1e0c"><div class="ttname"><a href="_serial_port_8cpp.html#a6362cdaadde6e3f843a85a3713bb1e0c">process</a></div><div class="ttdeci">void process(SerialPort *serial)</div><div class="ttdoc">Funkcja wykonywana przez wątek czytający.</div><div class="ttdef"><b>Definition</b> <a href="_serial_port_8cpp_source.html#l00194">SerialPort.cpp:194</a></div></div>
<div class="ttc" id="a_serial_port_8cpp_html_a750bdeca814dbfc7b7010d4b30c56023"><div class="ttname"><a href="_serial_port_8cpp.html#a750bdeca814dbfc7b7010d4b30c56023">crc8</a></div><div class="ttdeci">char crc8(char *data_frame, int data_length)</div><div class="ttdoc">Oblicza sumę kontrolną otrzymanej ramki danych.</div><div class="ttdef"><b>Definition</b> <a href="_serial_port_8cpp_source.html#l00166">SerialPort.cpp:166</a></div></div>
<div class="ttc" id="a_serial_port_8hpp_html"><div class="ttname"><a href="_serial_port_8hpp.html">SerialPort.hpp</a></div><div class="ttdoc">Definicja klasy SerialPort.</div></div>
<div class="ttc" id="a_serial_port_8hpp_html_a21626d35c8ce984e1085d6224f0ba720"><div class="ttname"><a href="_serial_port_8hpp.html#a21626d35c8ce984e1085d6224f0ba720">parseDataFrame</a></div><div class="ttdeci">bool parseDataFrame(const char *data_frame, RobotData *data, int data_length)</div><div class="ttdoc">Analizuje otrzymaną ramkę danych.</div><div class="ttdef"><b>Definition</b> <a href="_serial_port_8cpp_source.html#l00102">SerialPort.cpp:102</a></div></div>
<div class="ttc" id="a_serial_port_8hpp_html_acdd0eacf8c0ad94beabef95f32d78009"><div class="ttname"><a href="_serial_port_8hpp.html#acdd0eacf8c0ad94beabef95f32d78009">FRAME_LIMIT</a></div><div class="ttdeci">#define FRAME_LIMIT</div><div class="ttdef"><b>Definition</b> <a href="_serial_port_8hpp_source.html#l00029">SerialPort.hpp:29</a></div></div>
<div class="ttc" id="aclass_robot_data_html"><div class="ttname"><a href="class_robot_data.html">RobotData</a></div><div class="ttdoc">Zbiór wszystkich danych otrzymywanych z robota.</div><div class="ttdef"><b>Definition</b> <a href="_robot_data_8hpp_source.html#l00017">RobotData.hpp:18</a></div></div>
<div class="ttc" id="aclass_robot_data_html_adc9b093e38bfe8ae8eaf3f70e5cacefa"><div class="ttname"><a href="class_robot_data.html#adc9b093e38bfe8ae8eaf3f70e5cacefa">RobotData::getVelocity</a></div><div class="ttdeci">void getVelocity(int velocity, int index)</div><div class="ttdoc">Aktualizuje prędkości silników.</div><div class="ttdef"><b>Definition</b> <a href="_robot_data_8hpp_source.html#l00071">RobotData.hpp:71</a></div></div>
<div class="ttc" id="aclass_robot_data_html_aee64ded96944fd7d61557f566a5c804f"><div class="ttname"><a href="class_robot_data.html#aee64ded96944fd7d61557f566a5c804f">RobotData::getDistance</a></div><div class="ttdeci">void getDistance(unsigned int distance, int index)</div><div class="ttdoc">Aktualizuje dane z czujników odległości.</div><div class="ttdef"><b>Definition</b> <a href="_robot_data_8hpp_source.html#l00049">RobotData.hpp:49</a></div></div>
<div class="ttc" id="aclass_robot_data_html_affa0add6183e662083841442a9976cb3"><div class="ttname"><a href="class_robot_data.html#affa0add6183e662083841442a9976cb3">RobotData::getCounter</a></div><div class="ttdeci">void getCounter(unsigned int counter, int index)</div><div class="ttdoc">Aktualizuje dane z transoptorów odbiciowych.</div><div class="ttdef"><b>Definition</b> <a href="_robot_data_8hpp_source.html#l00060">RobotData.hpp:60</a></div></div>
<div class="ttc" id="aclass_serial_port_html"><div class="ttname"><a href="class_serial_port.html">SerialPort</a></div><div class="ttdoc">Modeluje port szeregowy.</div><div class="ttdef"><b>Definition</b> <a href="_serial_port_8hpp_source.html#l00041">SerialPort.hpp:42</a></div></div>
<div class="ttc" id="aclass_serial_port_html_a04a364848114cc5e6d9fb618b6b0a66d"><div class="ttname"><a href="class_serial_port.html#a04a364848114cc5e6d9fb618b6b0a66d">SerialPort::keepReading</a></div><div class="ttdeci">bool keepReading()</div><div class="ttdoc">Metoda decydująca o kontynuacji czytania.</div><div class="ttdef"><b>Definition</b> <a href="_serial_port_8hpp_source.html#l00075">SerialPort.hpp:75</a></div></div>
<div class="ttc" id="aclass_serial_port_html_a19e9af50f81a100e0e9bbaa5e2027b3d"><div class="ttname"><a href="class_serial_port.html#a19e9af50f81a100e0e9bbaa5e2027b3d">SerialPort::returnDecriptor</a></div><div class="ttdeci">int returnDecriptor() const</div><div class="ttdoc">Zwraca deskryptor pliku.</div><div class="ttdef"><b>Definition</b> <a href="_serial_port_8hpp_source.html#l00063">SerialPort.hpp:63</a></div></div>
<div class="ttc" id="aclass_serial_port_html_a222bb0e736430908b2145a1e24459d67"><div class="ttname"><a href="class_serial_port.html#a222bb0e736430908b2145a1e24459d67">SerialPort::port_desc</a></div><div class="ttdeci">int port_desc</div><div class="ttdoc">Deskryptor pliku portu szeregowego.</div><div class="ttdef"><b>Definition</b> <a href="_serial_port_8hpp_source.html#l00057">SerialPort.hpp:57</a></div></div>
<div class="ttc" id="aclass_serial_port_html_a343697523d58e3812ba0999cfa122f2d"><div class="ttname"><a href="class_serial_port.html#a343697523d58e3812ba0999cfa122f2d">SerialPort::data</a></div><div class="ttdeci">RobotData data</div><div class="ttdoc">Dane z robota.</div><div class="ttdef"><b>Definition</b> <a href="_serial_port_8hpp_source.html#l00049">SerialPort.hpp:49</a></div></div>
<div class="ttc" id="aclass_serial_port_html_a58d7a924c500dbbd169ab7ed0f60afef"><div class="ttname"><a href="class_serial_port.html#a58d7a924c500dbbd169ab7ed0f60afef">SerialPort::endConnection</a></div><div class="ttdeci">bool endConnection()</div><div class="ttdoc">Kończy połączenie z portem szeregowym.</div><div class="ttdef"><b>Definition</b> <a href="_serial_port_8cpp_source.html#l00050">SerialPort.cpp:50</a></div></div>
<div class="ttc" id="aclass_serial_port_html_a97cc08ccce84780fd625ea8ae4dcc917"><div class="ttname"><a href="class_serial_port.html#a97cc08ccce84780fd625ea8ae4dcc917">SerialPort::keep_reading</a></div><div class="ttdeci">bool keep_reading</div><div class="ttdoc">Zmienna decydująca o działaniu wątku.</div><div class="ttdef"><b>Definition</b> <a href="_serial_port_8hpp_source.html#l00053">SerialPort.hpp:53</a></div></div>
<div class="ttc" id="aclass_serial_port_html_ab8617347c0bd495e80d39e563ec8e750"><div class="ttname"><a href="class_serial_port.html#ab8617347c0bd495e80d39e563ec8e750">SerialPort::startConnection</a></div><div class="ttdeci">bool startConnection()</div><div class="ttdoc">Otwiera port szeregowy.</div><div class="ttdef"><b>Definition</b> <a href="_serial_port_8cpp_source.html#l00028">SerialPort.cpp:28</a></div></div>
<div class="ttc" id="aclass_serial_port_html_aca7d6ec84770df9715926afd3226454b"><div class="ttname"><a href="class_serial_port.html#aca7d6ec84770df9715926afd3226454b">SerialPort::SerialPort</a></div><div class="ttdeci">SerialPort()</div><div class="ttdoc">Inicjalizuje obiekt klasy SerialPort.</div><div class="ttdef"><b>Definition</b> <a href="_serial_port_8cpp_source.html#l00013">SerialPort.cpp:13</a></div></div>
<div class="ttc" id="aclass_serial_port_html_af29d6aadc436a6440cfa66fbf8c403ad"><div class="ttname"><a href="class_serial_port.html#af29d6aadc436a6440cfa66fbf8c403ad">SerialPort::receiveData</a></div><div class="ttdeci">bool receiveData()</div><div class="ttdoc">Odbiera dane z portu.</div><div class="ttdef"><b>Definition</b> <a href="_serial_port_8cpp_source.html#l00069">SerialPort.cpp:69</a></div></div>
<div class="ttc" id="aodbieranie_8hh_html_aac03f023f654bbad587c2f5c0894e0bf"><div class="ttname"><a href="odbieranie_8hh.html#aac03f023f654bbad587c2f5c0894e0bf">RS232_Odbierz</a></div><div class="ttdeci">bool RS232_Odbierz(int DeskPortu, std::string &amp;Bufor, unsigned int IloscZnakow, unsigned int CzasOczekiwania_ms=2000)</div></div>
<div class="ttc" id="atransparam_8hh_html_adae5ef433c18e71af7b1a18cd4c107e6"><div class="ttname"><a href="transparam_8hh.html#adae5ef433c18e71af7b1a18cd4c107e6">SetTransParam</a></div><div class="ttdeci">bool SetTransParam(int PortDesc, Type4BaudRate BRate=B_115200, Type4Parity Parity=P_None, Type4CharacterSize CSize=CS_8)</div><div class="ttdoc">Ustawianie parametrów transmisji.</div><div class="ttdef"><b>Definition</b> <a href="transparam_8cpp_source.html#l00133">transparam.cpp:133</a></div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_4aa64b0872d36146e049722e293482e3.html">prj</a></li><li class="navelem"><a class="el" href="dir_400757c3a0df52e783ed9699284f29ce.html">src</a></li><li class="navelem"><a class="el" href="_serial_port_8cpp.html">SerialPort.cpp</a></li>
    <li class="footer">Wygenerowano przez <a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.7 </li>
  </ul>
</div>
</body>
</html>
